Index: main/waeup.fceokene/trunk/src/waeup/fceokene/students/browser.py
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/students/browser.py	(revision 9952)
+++ main/waeup.fceokene/trunk/src/waeup/fceokene/students/browser.py	(revision 9953)
@@ -85,25 +85,10 @@
 class CustomStartClearancePage(StartClearancePage):
 
-    grok.template('startclearance')
-
-    def update(self, SUBMIT=None):
-        if not self.context.state == ADMITTED:
-            self.flash(_("Wrong state"))
-            self.redirect(self.url(self.context))
-            return
-        if not self.portrait_uploaded:
-            self.flash(_("No portrait uploaded."))
-            self.redirect(self.url(self.context, 'change_portrait'))
-            return
-        if not self.all_required_fields_filled:
-            self.flash(_("Not all required fields filled."))
-            self.redirect(self.url(self.context, 'edit_base'))
-            return
-        if SUBMIT is None:
-            return
-        IWorkflowInfo(self.context).fireTransition('start_clearance')
-        self.flash(_('Clearance process has been started.'))
-        self.redirect(self.url(self.context,'cedit'))
-        return
+    @property
+    def with_ac(self):
+        mode = getattr(self.context, 'current_mode', None)
+        if mode and mode.startswith('ug'):
+            return True
+        return False
 
 class CustomStudentClearanceEditFormPage(NigeriaStudentClearanceEditFormPage):
@@ -117,5 +102,4 @@
     """ Page to add an online payment ticket
     """
-    grok.template('bookbed')
     buttonname = _('Create bed ticket')
     notice = ''
Index: main/waeup.fceokene/trunk/src/waeup/fceokene/students/browser_templates/bookbed.pt
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/students/browser_templates/bookbed.pt	(revision 9952)
+++ 	(revision )
@@ -1,11 +1,0 @@
-<form method="POST" i18n:domain="waeup.fceokene">
-
-  <p i18n:translate="">
-    You data have been approved. You can book a bed by
-    clicking the button below.
-  </p>
-
-  <input type="submit" name="SUBMIT" class="btn primary"
-         tal:attributes="value view/buttonname" />
-
-</form>
Index: main/waeup.fceokene/trunk/src/waeup/fceokene/students/browser_templates/startclearance.pt
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/students/browser_templates/startclearance.pt	(revision 9952)
+++ 	(revision )
@@ -1,11 +1,0 @@
-<form method="POST" i18n:domain="waeup.fceokene">
-
-  <p i18n:translate="">
-    You data have been approved. You can start clearance now by
-    clicking the button below.
-  </p>
-
-  <input type="submit" name="SUBMIT" class="btn primary"
-         tal:attributes="value view/buttonname" />
-
-</form>
Index: main/waeup.fceokene/trunk/src/waeup/fceokene/students/tests/test_browser.py
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/students/tests/test_browser.py	(revision 9952)
+++ main/waeup.fceokene/trunk/src/waeup/fceokene/students/tests/test_browser.py	(revision 9953)
@@ -314,9 +314,15 @@
             name='upload_passportuploadedit').click()
         self.browser.open(self.student_path + '/start_clearance')
-        # In Okene the students can just start clearance without entering
-        # an activation code.
+        # In Okene the ug students start clearance with activation code ...
+        self.assertTrue('Activation Code:' in self.browser.contents)
         self.browser.getControl("Start clearance now").click()
-        self.assertMatches('...Clearance process has been started...',
-                           self.browser.contents)
+        self.assertTrue('Activation code is invalid' in self.browser.contents)
+        # ... and nce students without.
+        self.certificate.study_mode = 'nce_ft'
+        self.browser.open(self.student_path + '/start_clearance')
+        self.assertFalse('Activation Code:' in self.browser.contents)
+        self.browser.getControl("Start clearance now").click()
+        self.assertTrue(
+            'Clearance process has been started' in self.browser.contents)
 
     def test_student_accommodation(self):
Index: main/waeup.fceokene/trunk/src/waeup/fceokene/students/utils.py
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/students/utils.py	(revision 9952)
+++ main/waeup.fceokene/trunk/src/waeup/fceokene/students/utils.py	(revision 9953)
@@ -131,5 +131,5 @@
                     else:
                         amount = 15400
-                # NCE I fresh
+                # NCE/UG I fresh
                 elif student.current_level == 100 and student.state == CLEARED:
                     if student.depcode in ARTS:
@@ -137,5 +137,5 @@
                     else:
                         amount = 12495
-                # NCE II
+                # NCE/UG II
                 elif student.current_level in (100, 110, 120) and \
                     student.state == RETURNING:
@@ -144,5 +144,5 @@
                     else:
                         amount = 11545
-                # NCE III
+                # NCE/UG III
                 elif student.current_level in (200, 210, 220):
                     if student.depcode in ARTS:
@@ -150,5 +150,5 @@
                     else:
                         amount = 11545
-                # NCE III repeater
+                # NCE/UG III repeater
                 elif student.current_level in (300, 310, 320) and \
                     student.current_verdict == 'O':
@@ -157,5 +157,5 @@
                     else:
                         amount = 6773
-                # NCE III spillover
+                # NCE/UG III spillover
                 elif student.current_level in (300, 310, 320) and \
                     student.current_verdict == 'B':
@@ -164,5 +164,5 @@
                     else:
                         amount = 9645
-                # NCE III second spillover
+                # NCE/UG III second spillover
                 elif student.current_level in (400, 410, 420) and \
                     student.current_verdict == 'B':
@@ -177,5 +177,5 @@
                     else:
                         amount = 22400
-                # NCE II
+                # NCE/UG II
                 elif student.current_level in (100, 110, 120) and \
                     student.state == RETURNING:
@@ -184,5 +184,5 @@
                     else:
                         amount = 18900
-                # NCE III
+                # NCE/UG III
                 elif student.current_level in (200, 210, 220):
                     if student.depcode in ARTS:
@@ -190,5 +190,5 @@
                     else:
                         amount = 20900
-                # NCE IV
+                # NCE/UG IV
                 elif student.current_level in (300, 310, 320):
                     if student.depcode in ARTS:
@@ -196,5 +196,5 @@
                     else:
                         amount = 18900
-                # NCE V
+                # NCE/UG V
                 elif student.current_level in (400, 410, 420):
                     if student.depcode in ARTS:
@@ -202,5 +202,5 @@
                     else:
                         amount = 18900
-                # NCE V spillover
+                # NCE/UG V spillover
                 elif student.current_level in (500, 510, 520) and \
                     student.current_verdict == 'B':
@@ -209,5 +209,5 @@
                     else:
                         amount = 17400
-                # NCE V second spillover
+                # NCE/UG V second spillover
                 elif student.current_level in (600, 610, 620) and \
                     student.current_verdict == 'B':