Index: main/waeup.fceokene/trunk/src/waeup/fceokene/interswitch/browser.py
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/interswitch/browser.py	(revision 9951)
+++ main/waeup.fceokene/trunk/src/waeup/fceokene/interswitch/browser.py	(revision 9956)
@@ -126,6 +126,14 @@
             xmldict['institution_acct'] = "1012044132"
             xmldict['institution_bank_id'] = '117'
+        elif self.context.p_category == 'clearance':
+            fceokene_split_amt = 0.0
+            provider_amt = 0.0
+            self.pay_item_id = '8304'
+            xmldict['institution_amt'] = 100 * (
+                self.context.amount_auth - GATEWAY_AMT)
+            xmldict['institution_acct'] = "2003670143"
+            xmldict['institution_bank_id'] = '8'
+
         # Interswitch amount is not part of the xml data
-
         if self.context.p_category == 'schoolfee':
             xmltext = """<payment_item_detail>
@@ -137,5 +145,5 @@
 </payment_item_detail>""" % xmldict
 
-        elif 'maintenance' in self.context.p_category:
+        else:
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
Index: main/waeup.fceokene/trunk/src/waeup/fceokene/interswitch/tests.py
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/interswitch/tests.py	(revision 9951)
+++ main/waeup.fceokene/trunk/src/waeup/fceokene/interswitch/tests.py	(revision 9956)
@@ -63,7 +63,6 @@
         self.assertMatches('...Amount Authorized...',
                            self.browser.contents)
-        self.assertMatches(
-            '...<span>12495.0</span>...',
-            self.browser.contents)
+        self.assertTrue(
+            '<span>12495.0</span>' in self.browser.contents)
         self.payment_url = self.browser.url
 
@@ -93,16 +92,16 @@
         self.assertMatches('...Total Amount Authorized:...',
                            self.browser.contents)
-        self.assertMatches(
-            '...<input type="hidden" name="amount" value="1249500.0" />...',
-            self.browser.contents)
-        self.assertMatches(
-            '...item_name="School Fee" item_amt="934800" bank_id="117" acct_num="1012044015"...',
-            self.browser.contents)
-        self.assertMatches(
-            '...item_name="FCEOkene Split" item_amt="140000" bank_id="117" acct_num="1012044039"...',
-            self.browser.contents)
-        self.assertMatches(
-            '...item_name="BT Education" item_amt="160000" bank_id="31" acct_num="0026781725"...',
-            self.browser.contents)
+        self.assertTrue(
+            '<input type="hidden" name="amount" value="1249500.0" />'
+            in self.browser.contents)
+        self.assertTrue(
+            'item_name="School Fee" item_amt="934500" bank_id="117" acct_num="1012044015"'
+            in self.browser.contents)
+        self.assertTrue(
+            'item_name="FCEOkene Split" item_amt="140000" bank_id="117" acct_num="1012044039"'
+            in self.browser.contents)
+        self.assertTrue(
+            'item_name="BT Education" item_amt="160000" bank_id="31" acct_num="0026781725"'
+            in self.browser.contents)
 
         # Let's do the same for maintenance fee payment
@@ -138,7 +137,6 @@
         self.assertMatches('...Amount Authorized...',
                            self.browser.contents)
-        self.assertMatches(
-            '...<span>4150.0</span>...',
-            self.browser.contents)
+        self.assertTrue(
+            '<span>4150.0</span>' in self.browser.contents)
         self.payment_url = self.browser.url
         self.assertEqual(self.student['payments'][value].provider_amt, 0.0)
@@ -155,10 +153,49 @@
         self.assertMatches('...Total Amount Authorized:...',
                            self.browser.contents)
-        self.assertMatches(
-            '...<input type="hidden" name="amount" value="400000.0" />...',
+        self.assertTrue(
+            '<input type="hidden" name="amount" value="415000.0" />'
+            in self.browser.contents)
+        self.assertTrue(
+            'item_name="Hostel Maintenance Fee" item_amt="400000" bank_id="117" acct_num="1012044132"'
+            in self.browser.contents)
+        # BT does nor charge a fee for maintenance fee
+        self.assertFalse("BT Education" in self.browser.contents)
+
+        # Let's do the same for acceptance fee
+
+        self.browser.open(self.payments_path)
+        self.browser.open(self.payments_path + '/addop')
+        self.browser.getControl(
+            name="form.p_category").value = ['clearance']
+        self.browser.getControl("Create ticket").click()
+        self.assertMatches('...ticket created...',
+                           self.browser.contents)
+        ctrl = self.browser.getControl(name='val_id')
+        value = ctrl.options[2]
+        self.browser.getLink(value).click()
+        self.assertMatches('...Amount Authorized...',
+                           self.browser.contents)
+        self.assertTrue(
+            '<span>3456.0</span>' in self.browser.contents)
+        self.payment_url = self.browser.url
+        self.assertEqual(self.student['payments'][value].provider_amt, 0.0)
+        self.assertEqual(self.student['payments'][value].gateway_amt, 0.0)
+        self.assertEqual(self.student['payments'][value].thirdparty_amt, 0.0)
+        # Manager can access InterswitchForm
+        self.browser.getLink("CollegePAY", index=0).click()
+        # Split amounts have been set
+        self.assertEqual(self.student['payments'][value].provider_amt, 0.0)
+        self.assertEqual(self.student['payments'][value].gateway_amt, 150.0)
+        self.assertEqual(self.student['payments'][value].thirdparty_amt, 0.0)
+        # The total amount to be processed by Interswitch
+        # has been reduced by the Interswitch fee of 150 Nairas
+        self.assertMatches('...Total Amount Authorized:...',
+                           self.browser.contents)
+        self.assertTrue(
+            '<input type="hidden" name="amount" value="345600.0" />' in
             self.browser.contents)
-        self.assertMatches(
-            '...item_name="Hostel Maintenance Fee" item_amt="385000" bank_id="117" acct_num="1012044132"...',
-            self.browser.contents)
+        self.assertTrue(
+            'item_name="Acceptance Fee" item_amt="330600" bank_id="8" acct_num="2003670143"'
+            in self.browser.contents)
         # BT does nor charge a fee for maintenance fee
         self.assertFalse("BT Education" in self.browser.contents)
@@ -289,7 +326,7 @@
         self.assertMatches('...Total Amount Authorized:...',
                            self.browser.contents)
-        self.assertMatches(
-            '...<input type="hidden" name="amount" value="100000.0" />...',
-            self.browser.contents)
+        self.assertTrue(
+            '<input type="hidden" name="amount" value="100000.0" />'
+            in self.browser.contents)
 
     @external_test