Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/browser.py	(revision 9983)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/browser.py	(revision 9984)
@@ -651,5 +651,5 @@
     grok.name('index')
     grok.require('waeup.viewApplication')
-    form_fields = grok.AutoFields(IApplicantOnlinePayment)
+    form_fields = grok.AutoFields(IApplicantOnlinePayment).omit('p_item')
     form_fields[
         'creation_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
@@ -696,5 +696,5 @@
     grok.name('payment_slip.pdf')
     grok.require('waeup.viewApplication')
-    form_fields = grok.AutoFields(IApplicantOnlinePayment)
+    form_fields = grok.AutoFields(IApplicantOnlinePayment).omit('p_item')
     form_fields['creation_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
     form_fields['payment_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/browser_templates/applicantdisplaypage.pt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/browser_templates/applicantdisplaypage.pt	(revision 9983)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/browser_templates/applicantdisplaypage.pt	(revision 9984)
@@ -59,5 +59,5 @@
       <td tal:content="python: layout.formatDatetime(value.payment_date)">PAYMENT DATE</td>
       <td tal:content ="value/category">CATEGORY</td>
-      <td tal:content ="value/p_item">ITEM</td>
+      <td tal:content ="value/display_item">ITEM</td>
       <td tal:content ="value/state">STATE</td>
     </tr>
Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/browser_templates/applicanteditpage.pt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/browser_templates/applicanteditpage.pt	(revision 9983)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/browser_templates/applicanteditpage.pt	(revision 9984)
@@ -109,5 +109,5 @@
         <td tal:content="python: layout.formatDatetime(cl.payment_date)">PAYMENT DATE</td>
       <td tal:content ="cl/category">CATEGORY</td>
-      <td tal:content ="cl/p_item">ITEM</td>
+      <td tal:content ="cl/display_item">ITEM</td>
       <td tal:content ="cl/state">STATE</td>
       </tr>
Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/payment.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/payment.py	(revision 9983)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/payment.py	(revision 9984)
@@ -75,5 +75,6 @@
         return self.doAfterApplicantPaymentApproval()
 
-ApplicantOnlinePayment = attrs_to_fields(ApplicantOnlinePayment)
+ApplicantOnlinePayment = attrs_to_fields(
+    ApplicantOnlinePayment, omit=['display_item'])
 
 class PaymentWebservice(grok.Adapter):
Index: main/waeup.kofa/trunk/src/waeup/kofa/payments/interfaces.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/payments/interfaces.py	(revision 9983)
+++ main/waeup.kofa/trunk/src/waeup/kofa/payments/interfaces.py	(revision 9984)
@@ -55,7 +55,13 @@
 
     p_item = schema.TextLine(
-        title = _(u'Payment Item'),
+        title = u'',
         default = None,
         required = False,
+        )
+
+    display_item = schema.TextLine(
+        title = _(u'Payment Item'),
+        required = False,
+        readonly = True,
         )
 
Index: main/waeup.kofa/trunk/src/waeup/kofa/payments/payment.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/payments/payment.py	(revision 9983)
+++ main/waeup.kofa/trunk/src/waeup/kofa/payments/payment.py	(revision 9984)
@@ -65,4 +65,8 @@
         return utils.PAYMENT_CATEGORIES[self.p_category]
 
+    @property
+    def display_item(self):
+        return self.p_item
+
 class OnlinePayment(Payment):
     """This is an online payment.
@@ -98,3 +102,3 @@
         return
 
-OnlinePayment = attrs_to_fields(OnlinePayment)
+OnlinePayment = attrs_to_fields(OnlinePayment, omit=['display_item'])
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/accommodation.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/accommodation.py	(revision 9983)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/accommodation.py	(revision 9984)
@@ -76,4 +76,8 @@
             return None
 
+    @property
+    def display_coordinates(self):
+        return self.bed_coordinates
+
     def writeLogMessage(self, view, message):
         return self.__parent__.__parent__.writeLogMessage(view, message)
@@ -83,5 +87,6 @@
             self.booking_session).title
 
-BedTicket = attrs_to_fields(BedTicket)
+BedTicket = attrs_to_fields(BedTicket, omit=['display_coordinates'])
+
 
 # Bed tickets must be importable. So we might need a factory.
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py	(revision 9983)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py	(revision 9984)
@@ -1596,5 +1596,5 @@
     grok.name('index')
     grok.require('waeup.viewStudent')
-    form_fields = grok.AutoFields(IStudentOnlinePayment)
+    form_fields = grok.AutoFields(IStudentOnlinePayment).omit('p_item')
     form_fields[
         'creation_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
@@ -1650,5 +1650,5 @@
     grok.name('payment_slip.pdf')
     grok.require('waeup.viewStudent')
-    form_fields = grok.AutoFields(IStudentOnlinePayment)
+    form_fields = grok.AutoFields(IStudentOnlinePayment).omit('p_item')
     form_fields['creation_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
     form_fields['payment_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
@@ -1872,5 +1872,5 @@
         self.context.writeLogMessage(self, 'booked: %s' % bed.bed_id)
         self.flash(_('Bed ticket created and bed booked: ${a}',
-            mapping = {'a':bedticket.bed_coordinates}))
+            mapping = {'a':bedticket.display_coordinates}))
         self.redirect(self.url(self.context))
         return
@@ -1882,5 +1882,5 @@
     grok.name('index')
     grok.require('waeup.handleAccommodation')
-    form_fields = grok.AutoFields(IBedTicket)
+    form_fields = grok.AutoFields(IBedTicket).omit('bed_coordinates')
     form_fields['booking_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
     pnav = 4
@@ -1897,5 +1897,5 @@
     grok.name('bed_allocation_slip.pdf')
     grok.require('waeup.handleAccommodation')
-    form_fields = grok.AutoFields(IBedTicket)
+    form_fields = grok.AutoFields(IBedTicket).omit('bed_coordinates')
     form_fields['booking_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
     prefix = 'form'
@@ -1993,5 +1993,5 @@
         self.context.writeLogMessage(self, 'relocated: %s' % new_bed.bed_id)
         self.flash(_('Student relocated: ${a}',
-            mapping = {'a':self.context.bed_coordinates}))
+            mapping = {'a':self.context.display_coordinates}))
         self.redirect(self.url(self.context))
         return
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/accommodationmanagepage.pt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/accommodationmanagepage.pt	(revision 9983)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/accommodationmanagepage.pt	(revision 9984)
@@ -22,5 +22,5 @@
         <span tal:content="python: cl.getSessionString()">PID</span></a></td>
         <td tal:content="python: layout.formatDatetime(cl.booking_date)">DATE</td>
-        <td tal:content="cl/bed_coordinates">COORDINATES</td>
+        <td tal:content="cl/display_coordinates">COORDINATES</td>
         <td tal:content="cl/bed_type">TYPE</td>
       </tr>
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/paymentsmanagepage.pt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/paymentsmanagepage.pt	(revision 9983)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/paymentsmanagepage.pt	(revision 9984)
@@ -29,5 +29,5 @@
         <td tal:content="python: layout.formatDatetime(cl.payment_date)">PAYMENT DATE</td>
       <td nowrap tal:content ="cl/category">CATEGORY</td>
-      <td tal:content ="cl/p_item">ITEM</td>
+      <td tal:content ="cl/display_item">ITEM</td>
       <td tal:content ="cl/amount_auth">AMOUNT</td>
       <td tal:content ="cl/p_session">SESSION</td>
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/export.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/export.py	(revision 9983)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/export.py	(revision 9984)
@@ -283,6 +283,7 @@
     fields = tuple(
         sorted(iface_names(
-            IStudentOnlinePayment, exclude_attribs=False))) + (
-                'student_id','student_state','current_session')
+            IStudentOnlinePayment, exclude_attribs=False,
+            omit=['display_item']))) + (
+            'student_id','student_state','current_session')
 
     #: The title under which this exporter will be displayed
@@ -311,6 +312,7 @@
     fields = tuple(
         sorted(iface_names(
-            IBedTicket, exclude_attribs=False))) + (
-                'student_id', 'actual_bed_type')
+            IBedTicket, exclude_attribs=False,
+            omit=['display_coordinates']))) + (
+            'student_id', 'actual_bed_type')
 
     #: The title under which this exporter will be displayed
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/interfaces.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/interfaces.py	(revision 9983)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/interfaces.py	(revision 9984)
@@ -674,7 +674,13 @@
 
     bed_coordinates = schema.TextLine(
+        title = u'',
+        required = True,
+        readonly = False,
+        )
+
+    display_coordinates = schema.TextLine(
         title = _(u'Allocated Bed'),
-        required = True,
-        readonly = False,
+        required = False,
+        readonly = True,
         )
 
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/payments.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/payments.py	(revision 9983)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/payments.py	(revision 9984)
@@ -139,5 +139,6 @@
 
 
-StudentOnlinePayment = attrs_to_fields(StudentOnlinePayment)
+StudentOnlinePayment = attrs_to_fields(
+    StudentOnlinePayment, omit=['display_item'])
 
 class PaymentWebservice(grok.Adapter):