Index: /main/waeup.kofa/trunk/src/waeup/kofa/applicants/payment.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/applicants/payment.py	(revision 10029)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/applicants/payment.py	(revision 10030)
@@ -27,5 +27,5 @@
 from waeup.kofa.interfaces import MessageFactory as _
 from waeup.kofa.payments import OnlinePayment
-from waeup.kofa.payments.interfaces import IPaymentWebservice
+from waeup.kofa.payments.interfaces import IPayer
 from waeup.kofa.applicants.interfaces import IApplicantOnlinePayment
 from waeup.kofa.utils.helpers import attrs_to_fields
@@ -78,23 +78,23 @@
     ApplicantOnlinePayment, omit=['display_item'])
 
-class PaymentWebservice(grok.Adapter):
-    """An adapter to publish applicant data through a webservice.
+class Payer(grok.Adapter):
+    """An adapter to publish applicant data through a simple webservice.
     """
     grok.context(IApplicantOnlinePayment)
-    grok.implements(IPaymentWebservice)
+    grok.implements(IPayer)
 
     @property
     def display_fullname(self):
-        "Name of  payee"
+        "Name of  payer"
         return self.context.__parent__.display_fullname
 
     @property
     def id(self):
-        "Id of payee"
+        "Id of payer"
         return self.context.__parent__.applicant_id
 
     @property
     def reg_number(self):
-        "Reg number of payee"
+        "Reg number of payer"
         return self.context.__parent__.reg_number
 
Index: /main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py	(revision 10029)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py	(revision 10030)
@@ -37,5 +37,5 @@
 from waeup.kofa.testing import FunctionalLayer, FunctionalTestCase
 from waeup.kofa.app import University
-from waeup.kofa.payments.interfaces import IPaymentWebservice
+from waeup.kofa.payments.interfaces import IPayer
 from waeup.kofa.configuration import SessionConfiguration
 from waeup.kofa.applicants.container import ApplicantsContainer
@@ -758,11 +758,11 @@
         self.assertEqual(payment.p_category,'application')
         self.assertEqual(payment.amount_auth,200.0)
-        # Applicant is payee of the payment ticket.
+        # Applicant is payer of the payment ticket.
         self.assertEqual(
-            IPaymentWebservice(payment).display_fullname, 'John Anthony Tester')
+            IPayer(payment).display_fullname, 'John Anthony Tester')
         self.assertEqual(
-            IPaymentWebservice(payment).id, self.applicant.applicant_id)
-        self.assertEqual(IPaymentWebservice(payment).faculty, '')
-        self.assertEqual(IPaymentWebservice(payment).department, '')
+            IPayer(payment).id, self.applicant.applicant_id)
+        self.assertEqual(IPayer(payment).faculty, '')
+        self.assertEqual(IPayer(payment).department, '')
         # The pdf payment slip can't yet be opened
         #self.browser.open(payment_url + '/payment_receipt.pdf')
Index: /main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_payment.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_payment.py	(revision 10029)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_payment.py	(revision 10030)
@@ -22,6 +22,6 @@
 from zope.interface import verify
 from waeup.kofa.applicants.payment import (
-    ApplicantOnlinePayment, ApplicantOnlinePaymentFactory, PaymentWebservice)
-from waeup.kofa.payments.interfaces import IOnlinePayment, IPaymentWebservice
+    ApplicantOnlinePayment, ApplicantOnlinePaymentFactory, Payer)
+from waeup.kofa.payments.interfaces import IOnlinePayment, IPayer
 
 class ApplicantOnlinePaymentFactoryTest(unittest.TestCase):
@@ -39,4 +39,4 @@
         assert implemented_by.isOrExtends(IOnlinePayment)
 
-    def test_webservice_interface(self):
-        verify.verifyClass(IPaymentWebservice, PaymentWebservice)
+    def test_payer_interface(self):
+        verify.verifyClass(IPayer, Payer)
Index: /main/waeup.kofa/trunk/src/waeup/kofa/payments/interfaces.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/payments/interfaces.py	(revision 10029)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/payments/interfaces.py	(revision 10030)
@@ -134,12 +134,13 @@
         "Approve an online payment and set to paid."
 
-class IPaymentWebservice(IKofaObject):
-    """An interface for a webservice.
+class IPayer(IKofaObject):
+    """An interface for an adapter to publish student and applicant data
+    through a simple webservice.
 
     """
-    display_fullname = Attribute('Name of  payee')
-    id = Attribute('Id of payee')
-    reg_number = Attribute('Reg number of payee')
-    matric_number = Attribute('Matric number of payee')
-    faculty = Attribute('Faculty of payee')
-    department = Attribute('Department of payee')
+    display_fullname = Attribute('Name of  payer')
+    id = Attribute('Id of payer')
+    reg_number = Attribute('Reg number of payer')
+    matric_number = Attribute('Matric number of payer')
+    faculty = Attribute('Faculty of payer')
+    department = Attribute('Department of payer')
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/payments.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/payments.py	(revision 10029)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/payments.py	(revision 10030)
@@ -26,5 +26,5 @@
     IStudentPaymentsContainer, IStudentNavigation, IStudentOnlinePayment)
 from waeup.kofa.payments import PaymentsContainer, OnlinePayment
-from waeup.kofa.payments.interfaces import IPaymentWebservice
+from waeup.kofa.payments.interfaces import IPayer
 from waeup.kofa.utils.helpers import attrs_to_fields
 from waeup.kofa.accesscodes import create_accesscode
@@ -142,38 +142,38 @@
     StudentOnlinePayment, omit=['display_item'])
 
-class PaymentWebservice(grok.Adapter):
-    """An adapter to publish student data through a webservice.
+class Payer(grok.Adapter):
+    """An adapter to publish student data through a simple webservice.
     """
     grok.context(IStudentOnlinePayment)
-    grok.implements(IPaymentWebservice)
+    grok.implements(IPayer)
 
     @property
     def display_fullname(self):
-        "Name of  payee"
+        "Name of  payer"
         return self.context.student.display_fullname
 
     @property
     def id(self):
-        "Id of payee"
+        "Id of payer"
         return self.context.student.student_id
 
     @property
     def matric_number(self):
-        "Matric number or reg number of payee"
+        "Matric number or reg number of payer"
         return self.context.student.matric_number
 
     @property
     def reg_number(self):
-        "Reg number or reg number of payee"
+        "Reg number or reg number of payer"
         return self.context.student.reg_number
 
     @property
     def faculty(self):
-        "Faculty of payee"
+        "Faculty of payer"
         return self.context.student.faccode
 
     @property
     def department(self):
-        "Department of payee"
+        "Department of payer"
         return self.context.student.depcode
 
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py	(revision 10029)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py	(revision 10030)
@@ -38,5 +38,5 @@
 from waeup.kofa.testing import FunctionalLayer, FunctionalTestCase
 from waeup.kofa.app import University
-from waeup.kofa.payments.interfaces import IPaymentWebservice
+from waeup.kofa.payments.interfaces import IPayer
 from waeup.kofa.students.interfaces import IStudentsUtils
 from waeup.kofa.students.student import Student
@@ -2313,10 +2313,10 @@
         self.assertEqual(self.student['payments'][value].p_level, 200)
 
-        # Student is the payee of the payment ticket.
-        webservice = IPaymentWebservice(self.student['payments'][value])
-        self.assertEqual(webservice.display_fullname, 'Anna Tester')
-        self.assertEqual(webservice.id, self.student_id)
-        self.assertEqual(webservice.faculty, 'fac1')
-        self.assertEqual(webservice.department, 'dep1')
+        # Student is the payer of the payment ticket.
+        payer = IPayer(self.student['payments'][value])
+        self.assertEqual(payer.display_fullname, 'Anna Tester')
+        self.assertEqual(payer.id, self.student_id)
+        self.assertEqual(payer.faculty, 'fac1')
+        self.assertEqual(payer.department, 'dep1')
 
         # We simulate the approval
@@ -2795,5 +2795,5 @@
 
 class PublicPagesTests(StudentsFullSetup):
-    # Tests for swebservices
+    # Tests for simple webservices
 
     layer = FunctionalLayer
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_payment.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_payment.py	(revision 10029)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_payment.py	(revision 10030)
@@ -23,6 +23,6 @@
 from waeup.kofa.testing import FunctionalLayer, FunctionalTestCase
 from waeup.kofa.students.payments import (
-    StudentOnlinePayment, StudentOnlinePaymentFactory, PaymentWebservice)
-from waeup.kofa.payments.interfaces import IOnlinePayment, IPaymentWebservice
+    StudentOnlinePayment, StudentOnlinePaymentFactory, Payer)
+from waeup.kofa.payments.interfaces import IOnlinePayment, IPayer
 from waeup.kofa.students.interfaces import IStudentNavigation
 
@@ -49,4 +49,4 @@
         assert implemented_by.isOrExtends(IStudentNavigation)
 
-    def test_webservice_interface(self):
-        verify.verifyClass(IPaymentWebservice, PaymentWebservice)
+    def test_payer_interface(self):
+        verify.verifyClass(IPayer, Payer)
Index: /main/waeup.kofa/trunk/src/waeup/kofa/webservices.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/webservices.py	(revision 10029)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/webservices.py	(revision 10030)
@@ -20,11 +20,12 @@
 from zope.component import getUtility
 from zope.catalog.interfaces import ICatalog
-from waeup.kofa.payments.interfaces import IPaymentWebservice
+from waeup.kofa.payments.interfaces import IPayer
 from waeup.kofa.interfaces import IUniversity, academic_sessions_vocab
 
-# Kofa's webservices to requery payments from outside
+class PaymentDataWebservice(grok.View):
+    """A simple webservice to publish payment and payer details on request from
+    accepted IP addresses without authentication.
 
-class KofaPaymentRequest(grok.View):
-
+    """
     grok.context(IUniversity)
     grok.name('paymentrequest')
@@ -40,5 +41,5 @@
         real_ip = self.request.get('HTTP_X_FORWARDED_FOR', None)
         if real_ip:
-            self.context.logger.info('KofaPaymentRequest called: %s' % real_ip)
+            self.context.logger.info('PaymentDataWebservice called: %s' % real_ip)
         if real_ip and self.ACCEPTED_IP:
             if real_ip not in  self.ACCEPTED_IP:
@@ -52,5 +53,5 @@
             return
         try:
-            owner = IPaymentWebservice(results[0])
+            owner = IPayer(results[0])
             full_name = owner.display_fullname
             reg_number = owner.reg_number