Index: in/waeup.ngrentheme/trunk/waeup/ngrentheme/skins/waeup_ngrentheme_custom_templates/member_search_form.pt
===================================================================
--- /main/waeup.ngrentheme/trunk/waeup/ngrentheme/skins/waeup_ngrentheme_custom_templates/member_search_form.pt	(revision 10049)
+++ 	(revision )
@@ -1,133 +1,0 @@
-<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en"
-      xmlns:tal="http://xml.zope.org/namespaces/tal"
-      xmlns:metal="http://xml.zope.org/namespaces/metal"
-      xmlns:i18n="http://xml.zope.org/namespaces/i18n"
-      lang="en"
-      metal:use-macro="here/main_template/macros/master"
-      i18n:domain="waeup">
-
-<metal:block fill-slot="top_slot"
-             tal:define="dummy python:request.set('disable_border',1)" />
-
-<metal:main fill-slot="main"
-       tal:define="search_view here/@@pas_search;
-                   listing_allowed python: checkPermission('List portal members', here);
-                   results python:listing_allowed and here.portal_membership.searchForMembers();
-                   dummy python:results.sort(key=lambda x: x.getProperty('position') or '9999');
-                   DateTime python:modules['DateTime'].DateTime; 
-                   is_anonymous python:here.portal_membership.isAnonymousUser();
-                   is_manager python:test(here.portal_membership.checkPermission('Manage portal', here), 1, 0); ">
-
-   
-    <h1 class="documentFirstHeading"
-        i18n:translate="heading_list_members">Project Members</h1>
-        
-    <div class="documentByLine"
-        i18n:translate="name_not_listed">If you are a WAeUP member but don't see your name here, login with your credentials and fill the personal data form. 
-         After saving the form, your name will be automatically listed.</div>
-
-    <div id="content-core">
-        <p tal:condition="not: listing_allowed"
-            i18n:translate="member_listing_not_allowed">
-          You are not allowed to list portal members.
-        </p>
-        <div tal:condition="results">
-
-
-
-            <div tal:define="pm context/@@plone_tools/membership;
-                             portal_url context/@@plone_portal_state/portal_url">
-
-            <table align="left" width=100%>
-            <tbody>
-              <tal:repeat tal:define="Groups python:(('Nigeria','Nigerian Group'), ('Germany','German Group'), )"
-                          tal:repeat="Group Groups">
-              <tr><td colspan="5">
-                  <h2 style="padding: 0.5em 0em" tal:content="python:Group[1]" />
-              </td></tr>
-
-              <tal:block tal:repeat="result results">
-
-                    <tr style="border: 10px solid white"
-                        tal:define="id result/getUserName | nothing;
-                                    author python:pm.getMemberInfo(id) or {};
-                                    portrait python:pm.getPersonalPortrait(id);
-                                    position python:result.getProperty('position');
-                                    company python:result.getProperty('company');
-                                    home_base python:pm.getHomeUrl(id, verifyPermission=1);
-                                    show python: not id.endswith('1') and (author['fullname'] or not is_anonymous);
-                                    "
-                        tal:condition="python:Group[0] in result.getGroupNames() and show">
-    
-                      <td style="width: 8%; vertical-align:top;">
-                      <a href="#" tal:attributes="href portrait/absolute_url">
-                      <img src="" alt="" class="portraitPhoto"  width="60"
-                           style="float: left; margin: 0em;"
-                           tal:attributes="src portrait/absolute_url" />
-                      </a>
-                      </td>
-    
-                      <td style="width: 18%; vertical-align:top;">
-                       <span tal:condition="python: author['fullname']">
-                         <span tal:content="python: author['fullname']">name</span>
-                       </span>
-                       <span tal:condition="python: not author['fullname']">
-                         XXXXX
-                       </span>
-                       <span tal:condition="python: is_manager">
-                         <a href="#" tal:attributes="href string:${portal_url}/user-information?userid=${id}">
-                           (<span tal:content="id">id</span>)
-                         </a>
-                       </span>
-                      </td>
-
-                      <td style="width: 50%; padding: 0em 2em 0em 0em; vertical-align:top;">
-                       <span tal:content="author/description|nothing">Biography</span>
-                      </td>  
-                            
-                      <td style="width: 24%; vertical-align:top;">
-                       <span i18n:translate="company">Company</span>: <span tal:content="company|nothing">Company</span>
-                       <br />
-                       <span i18n:translate="location">Location</span>: <span tal:content="author/location|nothing">Location</span>
-                       <br />
-                       <span i18n:translate="position">Position</span>: <span tal:content="python: ' '.join(position.split()[1:])">Position</span>
-                       <div tal:condition="python: author['fullname'] and not is_anonymous">
-                         <a href="#" tal:attributes="href string:${portal_url}/author/${id}"
-                                     i18n:translate="send_feedback">
-                           Send Feedback
-                         </a>
-                       </div>
-                       <div tal:condition="python: author['fullname']">
-                         <a href="#" tal:attributes="href string:${portal_url}/Members/${id}"
-                                     i18n:translate="author_homepage">
-                           Homepage
-                         </a>
-                       </div>            
-                       <div tal:condition="python: id == pm.getAuthenticatedMember().id">
-                         <a href="#" tal:attributes="href string:${portal_url}/personalize_form"
-                                     i18n:translate="personal_preferences">
-                           Personal Preferences
-                         </a>
-                       </div>                                  
-                      </td>     
-                   </tr>
-
-              </tal:block>
-            </tal:repeat>
-            </tbody>
-            </table>
-
-            </div>
-            <div class="visualClear" id="clear-space-before-navigation"><!-- --></div>
-            <div class="visualClear" id="clear-space-after-navigation"><!-- --></div>
-
-        </div>
-
-        <div tal:condition="not: results">
-            <p><strong i18n:translate="description_no_results_found">No members found.</strong></p>
-        </div>
-    </div>
-
-</metal:main>
-
-</html>
Index: /main/waeup.ngrentheme/trunk/waeup/ngrentheme/skins/waeup_ngrentheme_custom_templates/member_search_form.pt_unused
===================================================================
--- /main/waeup.ngrentheme/trunk/waeup/ngrentheme/skins/waeup_ngrentheme_custom_templates/member_search_form.pt_unused	(revision 10050)
+++ /main/waeup.ngrentheme/trunk/waeup/ngrentheme/skins/waeup_ngrentheme_custom_templates/member_search_form.pt_unused	(revision 10050)
@@ -0,0 +1,133 @@
+<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en"
+      xmlns:tal="http://xml.zope.org/namespaces/tal"
+      xmlns:metal="http://xml.zope.org/namespaces/metal"
+      xmlns:i18n="http://xml.zope.org/namespaces/i18n"
+      lang="en"
+      metal:use-macro="here/main_template/macros/master"
+      i18n:domain="waeup">
+
+<metal:block fill-slot="top_slot"
+             tal:define="dummy python:request.set('disable_border',1)" />
+
+<metal:main fill-slot="main"
+       tal:define="search_view here/@@pas_search;
+                   listing_allowed python: checkPermission('List portal members', here);
+                   results python:listing_allowed and here.portal_membership.searchForMembers();
+                   dummy python:results.sort(key=lambda x: x.getProperty('position') or '9999');
+                   DateTime python:modules['DateTime'].DateTime; 
+                   is_anonymous python:here.portal_membership.isAnonymousUser();
+                   is_manager python:test(here.portal_membership.checkPermission('Manage portal', here), 1, 0); ">
+
+   
+    <h1 class="documentFirstHeading"
+        i18n:translate="heading_list_members">Project Members</h1>
+        
+    <div class="documentByLine"
+        i18n:translate="name_not_listed">If you are a WAeUP member but don't see your name here, login with your credentials and fill the personal data form. 
+         After saving the form, your name will be automatically listed.</div>
+
+    <div id="content-core">
+        <p tal:condition="not: listing_allowed"
+            i18n:translate="member_listing_not_allowed">
+          You are not allowed to list portal members.
+        </p>
+        <div tal:condition="results">
+
+
+
+            <div tal:define="pm context/@@plone_tools/membership;
+                             portal_url context/@@plone_portal_state/portal_url">
+
+            <table align="left" width=100%>
+            <tbody>
+              <tal:repeat tal:define="Groups python:(('Nigeria','Nigerian Group'), ('Germany','German Group'), )"
+                          tal:repeat="Group Groups">
+              <tr><td colspan="5">
+                  <h2 style="padding: 0.5em 0em" tal:content="python:Group[1]" />
+              </td></tr>
+
+              <tal:block tal:repeat="result results">
+
+                    <tr style="border: 10px solid white"
+                        tal:define="id result/getUserName | nothing;
+                                    author python:pm.getMemberInfo(id) or {};
+                                    portrait python:pm.getPersonalPortrait(id);
+                                    position python:result.getProperty('position');
+                                    company python:result.getProperty('company');
+                                    home_base python:pm.getHomeUrl(id, verifyPermission=1);
+                                    show python: not id.endswith('1') and (author['fullname'] or not is_anonymous);
+                                    "
+                        tal:condition="python:Group[0] in result.getGroupNames() and show">
+    
+                      <td style="width: 8%; vertical-align:top;">
+                      <a href="#" tal:attributes="href portrait/absolute_url">
+                      <img src="" alt="" class="portraitPhoto"  width="60"
+                           style="float: left; margin: 0em;"
+                           tal:attributes="src portrait/absolute_url" />
+                      </a>
+                      </td>
+    
+                      <td style="width: 18%; vertical-align:top;">
+                       <span tal:condition="python: author['fullname']">
+                         <span tal:content="python: author['fullname']">name</span>
+                       </span>
+                       <span tal:condition="python: not author['fullname']">
+                         XXXXX
+                       </span>
+                       <span tal:condition="python: is_manager">
+                         <a href="#" tal:attributes="href string:${portal_url}/user-information?userid=${id}">
+                           (<span tal:content="id">id</span>)
+                         </a>
+                       </span>
+                      </td>
+
+                      <td style="width: 50%; padding: 0em 2em 0em 0em; vertical-align:top;">
+                       <span tal:content="author/description|nothing">Biography</span>
+                      </td>  
+                            
+                      <td style="width: 24%; vertical-align:top;">
+                       <span i18n:translate="company">Company</span>: <span tal:content="company|nothing">Company</span>
+                       <br />
+                       <span i18n:translate="location">Location</span>: <span tal:content="author/location|nothing">Location</span>
+                       <br />
+                       <span i18n:translate="position">Position</span>: <span tal:content="python: ' '.join(position.split()[1:])">Position</span>
+                       <div tal:condition="python: author['fullname'] and not is_anonymous">
+                         <a href="#" tal:attributes="href string:${portal_url}/author/${id}"
+                                     i18n:translate="send_feedback">
+                           Send Feedback
+                         </a>
+                       </div>
+                       <div tal:condition="python: author['fullname']">
+                         <a href="#" tal:attributes="href string:${portal_url}/Members/${id}"
+                                     i18n:translate="author_homepage">
+                           Homepage
+                         </a>
+                       </div>            
+                       <div tal:condition="python: id == pm.getAuthenticatedMember().id">
+                         <a href="#" tal:attributes="href string:${portal_url}/personalize_form"
+                                     i18n:translate="personal_preferences">
+                           Personal Preferences
+                         </a>
+                       </div>                                  
+                      </td>     
+                   </tr>
+
+              </tal:block>
+            </tal:repeat>
+            </tbody>
+            </table>
+
+            </div>
+            <div class="visualClear" id="clear-space-before-navigation"><!-- --></div>
+            <div class="visualClear" id="clear-space-after-navigation"><!-- --></div>
+
+        </div>
+
+        <div tal:condition="not: results">
+            <p><strong i18n:translate="description_no_results_found">No members found.</strong></p>
+        </div>
+    </div>
+
+</metal:main>
+
+</html>