Index: main/waeup.ngrentheme/trunk/waeup/ngrentheme/skins/waeup_ngrentheme_styles/ploneCustom.css.dtml
===================================================================
--- main/waeup.ngrentheme/trunk/waeup/ngrentheme/skins/waeup_ngrentheme_styles/ploneCustom.css.dtml	(revision 10050)
+++ main/waeup.ngrentheme/trunk/waeup/ngrentheme/skins/waeup_ngrentheme_styles/ploneCustom.css.dtml	(revision 10052)
@@ -95,5 +95,5 @@
 div.portletAssignments div.portletHeader {
     padding: 0.4em 1em 0.4em 1em;
-    background: #ddd;
+    background: #EEEEEE;
     line-height: normal;
 }
@@ -116,39 +116,43 @@
   font-size: 1.25em;
   font-weight: bold;
-  color: #003d7d;
-}
-
-
-
-/* Change the ugly green of the sunburst theme */ 
+  color: #006633;
+}
+
+/* Change the ugly green of the sunburst theme */
 
 #portal-siteactions li a:hover {
-    color: #008036
+    color: #980000
 }
 #content a:hover,
 dl.portlet a:hover {
-    color: #008036 !important; /* This one gets an !important because it should always activate in the content area, even when state coloring is active */
+    color: #980000 !important; /* This one gets an !important because it should always activate in the content area, even when state coloring is active */
+}
+
+#content a:visited, dl.portlet a:visited {
+    color: #006633;
+    border-bottom: None;
 }
 #edit-bar {
-    background-color: #008036;
-    border: 0.25em solid #008036;
+    background-color: #C83333;
+    border: 0.25em solid #C83333;
     border-style: solid solid none solid;
 }
 
 #content-views {
-    background-color: #008036;
+    background-color: #C83333;
 }
 #contentActionMenus dl.actionMenu a,
 #contentActionMenus dl.actionMenu.activated dd {
-    background-color: #008036;
+    background-color: #C83333;
 }
 #contentActionMenus dl.actionMenu.activated dd {
-    border-bottom: 0.5em solid #008036;
+    border-bottom: None;
 }
 #contentActionMenus {
-    background: #008036;
+    background: #C83333;
 }
 div.overlay a:hover {
-    color: #008036;
+    color: #980000;
+    border-bottom: None;
 }
 
@@ -156,70 +160,70 @@
 
 #portal-globalnav {
-    background: #ddd;
+    background: #EEEEEE;
 }
 
 #portal-globalnav li a {
-    background: #ddd;
+    background: #EEEEEE;
 }
 #portal-globalnav .selected a:hover {
-    background: #ddd;
-    color: #003d7d;
+    background: #EEEEEE;
+    color: #006633;
 }
 .LSHighlight {
-    background: #ddd;
+    background: #EEEEEE;
 }
 dl.portlet dt,
 div.portletAssignments div.portletHeader {
-    background: #ddd;
+    background: #EEEEEE;
 }
 div.managePortletsLink,
 a.managePortletsFallback {
-    background: #ddd;
+    background: #EEEEEE;
 }
 dl.portlet ul.navTreeLevel0 > .navTreeItem {
-    border-bottom: 0.1em dotted #ddd;
+    border-bottom: 0.1em dotted #EEEEEE;
 }
 dl.portlet ul.navTree .navTreeCurrentItem {
-    background-color: #ddd;
-    border-left: 1em solid #ddd;
+    background-color: #EEEEEE;
+    border-left: 1em solid #EEEEEE;
 }
 #category a.link-category {
-    background: #ddd;
+    background: #EEEEEE;
 }
 table.plain th,
 table.plain td {
-    border: 1px solid #ddd;
+    border: 1px solid #EEEEEE;
 }
 table.listing {
-    border-left: 1px solid #ddd;
-    border-bottom: 1px solid #ddd;
+    border-left: 1px solid #EEEEEE;
+    border-bottom: 1px solid #EEEEEE;
 }
 table.listing .top {
-    border-left: 1px solid #ddd;
-    border-top: 1px solid #ddd;
-    border-right: 1px solid #ddd;
+    border-left: 1px solid #EEEEEE;
+    border-top: 1px solid #EEEEEE;
+    border-right: 1px solid #EEEEEE;
 }
 table.listing th {
     color: #666;
     border: 0.1em solid #e7e7e7;
-    background: #ddd;
+    background: #EEEEEE;
 }
 table.listing td {
-    border-right: 1px solid #ddd;
+    border-right: 1px solid #EEEEEE;
 }
 table.listing td.draggable {
-    background: #ddd !important;
+    background: #EEEEEE !important;
 }
 #content ul.formTabs {
-    background-color: #ddd;
-    border: 0.3em solid #ddd;
+    background-color: #EEEEEE;
+    border: 0.3em solid #EEEEEE;
 }
 img.image-left,
 img.image-right,
 .captioned img {
-    border: 1px solid #ddd;
+    border: 1px solid #EEEEEE;
 }
 #portal-footer {
-    background: #ddd;
+    background: #EEEEEE;
     line-height: 1em;
     padding-top: 0.5em;
@@ -227,45 +231,75 @@
 }
 #portal-sitemap > li {
-    border-bottom:0.1em dotted #ddd;
+    border-bottom:0.1em dotted #EEEEEE;
 }
 #content-history .historyByLine {
-    background: #ddd;
+    background: #EEEEEE;
 }
 #content-history div.historyComment {
-    border: 1px solid #ddd;
-}
+    border: 1px solid #EEEEEE;
+}
+
+#portal-personaltools {
+    background: #EEEEEE;
+}
+
+
+#portal-languageselector{
+    background: #EEEEEE;
+}
+
+
+dl.portalMessage a, #content dl.portalMessage a {
+    border-bottom: None;
+    color: #006633;
+}
+
 
 /* Change the dark blue of the sunburst theme */ 
 
 a:link, a:visited {
-    color: #003d7d;
+    color: #006633;
 }
 
 #portal-globalnav .selected a,
 #portal-globalnav a:hover {
-    background: #003d7d;
+    background: #006633;
 }
 
 #content a.link-overlay {
-    border-bottom: 1px dotted #003d7d !important;
+    border-bottom: None;
 }
 
 #content a:link,
 dl.portlet a:link {
-    color: #003d7d;
+    color: #006633;
+    border-bottom: None;
+}
+
+#content a:hover,
+dl.portlet a:hover {
+    border-bottom: None;
 }
 
 #category a.link-category:hover {
-    background: #003d7d;
-    border-color: #003d7d;
+    background: #006633;
+    border-color: #006633;
 }
 
 #portal-personaltools dd a:hover {
-    background: #003d7d;
-}
-
-
-
-
+    background: #006633;
+}
+
+
+/*
+** CONTENT.CSS CUSTOMIZATION STYLES
+*/
+
+
+.mceContentBody a {
+    background-color: transparent;
+    border-bottom: None;
+    color: #006633; !important;
+}
 
 